/*
 * tmos - beer.c
 * 	version 0.0.0
 * 
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 * Copyright (C) 2009  Marek Piwonski <marek@microster.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <tmos/crc16.h>
#include <tmos/jiffies.h>
#include <tmos/mb-slave.h>
#include <tmos/watchdog.h>
#include <tmos/trt.h>
#include <tmos/port.h>
#include <tmos/net.h>

static uint8_t __user addr;

static void beer_init(void) __reentrant
{
	port_t p;
	uint8_t address;
	msg_ssize_t ret;

	mb_slave_open(CONFIG_MODBUS_DEVICE);

	/*
	 * read network address from /dev/beersw
	 */
	kernel_enter();
	p = sys_port_open("/dev/beersw", O_RDONLY);
	kernel_exit();

	ret = port_read(p, &addr, 1);
	if (ret == 1) {
		address = addr;
		if (address == 0)
			address = 1;

		net_ioctl(NET_IFACE_SERIAL0, NET_IOCTL_SET_ADDR_BYTE, &address);
	}
}


void app_main(void) REENTRANT
{
	beer_init();
	for (;;) {
		watchdog_refresh();

		trt_poll();
	}
}
