/*
 * tmos - init_calls.c
 * 	version 0.0.0
 * 
 * Copyright (C) 2005..2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <asm/system.h>

extern unsigned int __code arch_init_len;
extern unsigned int __code arch_init_start;
extern unsigned int __code subsys_init_len;
extern unsigned int __code subsys_init_start;
extern unsigned int __code device_init_len;
extern unsigned int __code device_init_start;
extern unsigned int __code late_init_len;
extern unsigned int __code late_init_start;

void call_arch_initcalls(void) __reentrant
{
	unsigned int i;

	for (i = 0; i < arch_init_len; i += 2) {
		void (*init_call)(void) = (void __code *)
			(*((uint16_t __code *)(arch_init_start + i)));
		init_call();
	}
}

void call_subsys_initcalls(void) __reentrant
{
	unsigned int i;

	for (i = 0; i < subsys_init_len; i += 2) {
		void (*init_call)(void) = (void __code *)
			(*((uint16_t __code *)(subsys_init_start + i)));
		init_call();
	}
}

void call_device_initcalls(void) __reentrant
{
	unsigned int i;

	for (i = 0; i < device_init_len; i += 2) {
		void (*init_call)(void) = (void __code *)
			(*((uint16_t __code *)(device_init_start + i)));
		init_call();
	}
}

void call_late_initcalls(void) __reentrant
{
	unsigned int i;

	for (i = 0; i < late_init_len; i += 2) {
		void (*init_call)(void) = (void __code *)
			(*((uint16_t __code *)(late_init_start + i)));
		init_call();
	}
}

static void dummy(void) __naked
{
	__asm
		.area init_calls(CODE,REL,CON)
_arch_init_start:
		.db s_arch_initcall
		.db (s_arch_initcall >> 8)
_arch_init_len:
		.db l_arch_initcall
		.db (l_arch_initcall >> 8)
		
_subsys_init_start:
		.db s_subsys_initcall
		.db (s_subsys_initcall >> 8)
_subsys_init_len:
		.db l_subsys_initcall
		.db (l_subsys_initcall >> 8)
		
_device_init_start:
		.db s_device_initcall
		.db (s_device_initcall >> 8)
_device_init_len:
		.db l_device_initcall
		.db (l_device_initcall >> 8)

_late_init_start:
		.db s_late_initcall
		.db (s_late_initcall >> 8)
_late_init_len:
		.db l_late_initcall
		.db (l_late_initcall >> 8)
		
		.area arch_initcall(CODE,REL,CON)
		.area subsys_initcall(CODE,REL,CON)
		.area device_initcall(CODE,REL,CON)
		.area late_initcall(CODE,REL,CON)
	__endasm;
}
