/*
 * tmos - bdo5.c
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * Tiny RT BDO5 modules support
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Fundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <tmos/kernel.h>
#include <tmos/trt.h>
#include <tmos/adc.h>
#include <tmos/jiffies.h>

#define BIT_0	P2_1
#define BIT_1	P3_2
#define BIT_2	P3_7
#define BIT_3	P3_6
#define BIT_4	P3_5

static void bdo5_write(unsigned int x) __reentrant
{
	BIT_0 = (x >> 0) & 1;
	BIT_1 = (x >> 1) & 1;
	BIT_2 = (x >> 2) & 1;
	BIT_3 = (x >> 3) & 1;
	BIT_4 = (x >> 4) & 1;
}

void trt_bdo5_write(void) __reentrant
{
	treg_t x;

	x = trt_read_reg(CONFIG_TRT_BDO5_INPUTBASE);
	bdo5_write(x);
}
