/*
 * tmos - main.c
 * 	version 0.0.0
 *
 * Copyright (C) 2005..2010  Krzysztof Mazur <krzysiek@podlesie.net>
 * Copyright (C) 2005..2010  Marek Piwonski <marek@microster.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <asm/system.h>
#include <tmos/watchdog.h>
#include <tmos/sched.h>
#include <asm/irqs.h>

#ifdef CONFIG_MULTITASKING
struct context init_task;
#endif

#ifdef CONFIG_APP 
void app_main(void) REENTRANT;
#endif
  
void call_arch_initcalls(void) __reentrant;
void call_subsys_initcalls(void) __reentrant;
void call_device_initcalls(void) __reentrant;
void call_late_initcalls(void) __reentrant;

int main(void)
{
	arch_init();
	watchdog_init();
	call_arch_initcalls();
	call_subsys_initcalls();

#ifdef CONFIG_MULTITASKING
#ifdef CONFIG_TDATA
	init_task.tdata_page = page_alloc();
#endif
	context_init(&init_task);
	init_task.next = &init_task;
	current = &init_task;
#endif

	call_device_initcalls();
	local_irq_enable();

	call_late_initcalls();

#ifdef CONFIG_APP
	app_main();
#endif
	for (;;);
}
